/**
 * 
 */
package clime.messadmin.providers.spi;


/**
 * Base implementation class for DataProvider displaying tabular data.
 * @author C&eacute;drik LIME
 */
public abstract class BaseTabularDataProvider {

	/**
	 * 
	 */
	public BaseTabularDataProvider() {
		super();
	}

//	/**
//	 * @param object
//	 * @return specific data labels for given object, or null if it can be determined
//	 */
//	public abstract String[] getTabularDataLabels(final Object object);
//	/**
//	 * @param object
//	 * @return specific data values for given object, or null if it can be determined
//	 */
//	public abstract Object[][] getTabularData(final Object object);
//
//	protected abstract String getTableCaption(String[] labels, Object[][] data);
//
//	protected String getXHTMLData(Object object) {
//		try {
//			String[] labels = getTabularDataLabels(object);
//			Object[][] values = getTabularData(object);
//			return buildXHTML(labels, values, tableId, getTableCaption(labels, values));
//		} catch (RuntimeException rte) {
//			return "Error in " + this.getClass().getName() + ": " + rte;
//		}
//	}

	protected String buildXHTML(String[] labels, Object[][] values, String tableId, String tableCaption) {
		if (labels == null || values == null || labels.length == 0 || values.length == 0) {
			return "";
		}
		StringBuffer buff = new StringBuffer(1024);
		buff.append("<table id=\"").append(tableId).append("\" class=\"strippable\" style=\"text-align: left;\" border=\"1\" cellpadding=\"2\" cellspacing=\"2\">\n");
		buff.append("<caption style=\"font-variant: small-caps;\">").append(tableCaption).append("</caption>\n");
		buff.append("<thead><tr>\n");
		for (int i = 0; i < labels.length; ++i) {
			String label = labels[i];
			buff.append("<th>").append(label).append("</th>\n");
		}
		buff.append("</tr></thead><tbody>\n");
		for (int i = 0; i < values.length; ++i) {
			Object[] raw = values[i];
			buff.append("<tr>\n");
			for (int j = 0; j < raw.length; ++j) {
				Object value = raw[j];
				buff.append("<td>");
				if (value != null) {
					buff.append("<span title=\"").append(value.getClass()).append("\">");
					buff.append(value);
					buff.append("</span>");
				}
				buff.append("</td>");
			}
			buff.append("</tr>\n");
		}
		buff.append("</tbody></table>\n");
		return buff.toString();
	}
}
